import os, operator
import time
import sys
import logging
from stat import *
from ftplib import FTP
import Daemon
import grp
import shutil



class NOSSRVRDaemon(Daemon.Daemon):
    def run(self):
        global NOSFileDir, ARCHLog
        global AMVERWorkDir, NWSCollAddr, AOMLBUFRDestDir, DeliverBUFRFiles

        NOSFileDir = AMVERWorkDir+"NOSSRVR"
        if not os.path.exists(NOSFileDir+'/binfiles'):
            os.makedirs(NOSFileDir+'/binfiles')
            
        if not os.path.exists(NOSFileDir+'/archive'):
            os.makedirs(NOSFileDir+'/archive')
            
        if not os.path.exists(NOSFileDir+'/bufr_queue'):
            os.makedirs(NOSFileDir+'/bufr_queue')
            
        if not os.path.exists(NOSFileDir+'/bufr_queue/archive'):
            os.makedirs(NOSFileDir+'/bufr_queue/archive')
            
        if not os.path.exists(NOSFileDir+'/logfiles'):
            os.makedirs(NOSFileDir+'/logfiles')
            
        if not os.path.exists(NOSFileDir+'/nmc'):
            os.makedirs(NOSFileDir+'/nmc')
            
        if not os.path.exists(NOSFileDir+'/nmc/archive'):
            os.makedirs(NOSFileDir+'/nmc/archive')
            
        if not os.path.exists(AMVERWorkDir+'/MessSeq/NMCseq.txt'):
            seqfile = open(AMVERWorkDir+'MessSeq/NMCseq.txt','w')
            seqfile.write('0')
            seqfile.close()
            
            
        ARCHFile = NOSFileDir+"/logfiles/Logfile.log" 
        ARCHLog=logging.getLogger("ArchLog")
        ARCHLog.setLevel(logging.DEBUG)
        handler = logging.FileHandler(ARCHFile)
        Form = logging.Formatter('%(asctime)s %(levelname)-8s %(module)s %(lineno)d %(message)s','%a, %d %b %Y %H:%M:%S')
        handler.setFormatter(Form)
        ARCHLog.addHandler(handler)

        ARCHLog.debug('AMVERWorkDir = %s' %AMVERWorkDir)
        ARCHLog.debug('NWSCollAddr = %s' %NWSCollAddr)
        ARCHLog.debug('AOMLBUFRDestDir = %s' %AOMLBUFRDestDir)
        ARCHLog.debug('DeliverBUFRFiles = %s' %DeliverBUFRFiles)
#        ARCHLog.debug('AOMLNODCDestDir = %s' %AOMLNODCDestDir)
#        ARCHLog.debug('DeliverNDCFiles = %s' %DeliverNDCFiles)

        TimeTrig=False
        OneMinute = 0
        while True:
#            BuildNOSFiles()
#            BuildNMCFile()
#            sys.exit(0)
            while True:
                TM = time.gmtime(time.time())
                if TM.tm_hour%6 == 0 and TM.tm_min==0 and TimeTrig == False:
         #       if TM.tm_min%5==0 and TimeTrig == False:
                    TimeTrig = True
#                    print "min = twelve"
                    break
                else:
                    if TM.tm_hour%6 == 0 and TM.tm_min==0 and TimeTrig == True:
          #           if TM.tm_min%5==0 and TimeTrig==True:
                        time.sleep(60)
                        
                    else:
                        time.sleep(5)
                        TimeTrig=False
                        OneMinute+=1
                        if OneMinute == 12:
                            OneMinute=0
                            st = os.stat(pidfile) # Touch the pid file so we know we are still running
                            atime = st[ST_ATIME]
                            FT = time.time()
                            os.utime(pidfile,(atime,FT))
                        
#                    print TM
                    continue
            BuildNOSFiles()
            if TM.tm_hour == 6:
                BuildNMCFile()
#            sys.exit(0)
            
#****************************************************************************************
def BuildNMCFile():
    TM = time.gmtime(time.time())
    dirlist = os.listdir(NOSFileDir+'/nmc')
    NMCFile = open(NOSFileDir+'/nmc/%04d%02d%02d.nmc' %(TM.tm_year,TM.tm_mon,TM.tm_mday),'wb')
    for files in dirlist:
        if os.path.splitext(files)[1].find('.txt') < 0:
            continue
        curfile = open(NOSFileDir+'/nmc/'+files,'rb')
        curfile.seek(0,2)
        length  =  curfile.tell()
        curfile.seek(0)
        buf = curfile.read(length)
        curfile.close()
        os.unlink(NOSFileDir+'/nmc/'+files)
        NMCFile.write(buf)
    NMCFile.close()    
        
    
#****************************************************************************************
def RemoveBinFiles():
    global NOSFileDir
    dirlist = os.listdir(NOSFileDir+'/binfiles')
    for files in dirlist:
        BinPath = NOSFileDir+'/binfiles/'+files
        if(os.path.isdir(BinPath)):
           continue
        if os.path.splitext(files)[1].upper().find('.BIN')==0:
            os.unlink(BinPath)

#****************************************************************************************
def HandleBlock(block):
    global FTPfile
    FTPfile.write(block)
#    print ".",
            
#****************************************************************************************
def GetNextFileInfo():
    
    RetrieveFrom = 0
    OldestNOSFile = 2**32
    
    File2Write=""
    dirlist = os.listdir(NOSFileDir)
#    print dirlist
    for files in dirlist:
        Path = NOSFileDir+'/'+files
        if os.path.isdir(Path):
            continue
        if os.path.splitext(files)[1].upper()==".SRVR":
#           print "file is a .srvr file"
            FileStat = os.stat(Path)
            FT = FileStat[ST_MTIME]
            if FT > RetrieveFrom:
                RetrieveFrom = FT  ## this is the time to start retrieving files
                RF = time.gmtime(RetrieveFrom)
#                print RF
            if FT < OldestNOSFile:
                OldestNOSFile = FT
                OF = time.gmtime(OldestNOSFile)
                File2Write = files
#                File2Write = file+'02'
#            print FT
            
    if RetrieveFrom == 0: ## There were no NOSxx.SRVR Files in the directory so we will create them
##   	print 'Retrieve from = %d' %RetrieveFrom
        CurrentTime = time.time()
        for i in range(0,12):
            newfile = '/NOS%02d.SRVR' %(i+1)
            newfile = NOSFileDir+newfile
            fp = open(newfile,'wb')
            fp.close()
            FileStat = os.stat(newfile)
            newfiletime = CurrentTime - (21600*(12-i))
            os.utime(newfile,(FileStat[ST_ATIME],newfiletime))
##        File2Write = 'NOS01.SRVR02'
        RF = time.gmtime(os.stat(newfile)[ST_MTIME])
        OF = time.gmtime(os.stat(NOSFileDir+'/NOS01.SRVR')[ST_MTIME])
#    print "Latest NOS FILE time"
#    print RF
#    print "Oldest NOS FIle is %s" %File2Write
#    print OF
    return File2Write, RF


#*******************************************************************************
def RetrieveFiles(now):
    global FTPfile
#    NWSFTPAddr='tggate.nws.noaa.gov'
    RetrieveFlag = True
    try:
        ftp = FTP(NWSCollAddr)
        ftp.login("aoml", "nJy4B8O6")
        ftp.set_pasv(False)
        NLST = ftp.nlst()
        Start = now
    #    now = time.time()
    #    now -=21600
        TimeChange = False
        FirstFile = False
        for files in NLST:
            if files.find('sn.   0.bin')>=0:
                continue
            if os.path.splitext(files)[1].upper().find('.BIN')==0:
                ftime = ftp.sendcmd('MDTM '+files)
                TM = (int(ftime[4:8]),int(ftime[8:10]),int(ftime[10:12]),int(ftime[12:14]),int(ftime[14:16]),int(ftime[16:18]),0,0,-1)
                if time.mktime(TM)>= now:
                    TimeChange = True
                    TM1 = time.gmtime(time.mktime(TM))
    #               print 'FirstFile = %s' %FirstFile
                    if not FirstFile:
                        Start = (TM1,files)
                        End = (TM1,files)
                        FirstFile=True
                    else:
                        End = (TM1,files)
                        ## Retrieve the file
                    FileName = NOSFileDir+'/binfiles/'+files
                    FTPfile = open('%s'%FileName,'wb')
                    ftp.retrbinary('RETR %s' %files,HandleBlock)
                    FTPfile.close()
    #                print FileName, files, ftime
        #print NLST
    except Exception,e:
    	ARCHLog.exception(str(e))
    	ARCHLog.info("Failed to get the bin files from NWSTG")
        RetrieveFlag = True    	  
    try:
    	ftp.quit()
    except:
    	ftp.close()
    if not TimeChange:
        Start=0
        End=0
    return Start, End, RetrieveFlag

#**********************************************************************************
def BuildNOSFiles():
    
    
    RemoveBinFiles()
    
    seqfile=open(AMVERWorkDir+'/MessSeq/NMCseq.txt','r')
    nmcseq = int(seqfile.read())
    seqfile.close()

    Params = GetNextFileInfo()
#    print Params
    File2Write = Params[0]
    

    RetrFrom = time.mktime(Params[1])-15  ## Retrieve 15 seconds before filetime
#    print 'RetrFrom = ', RetrFrom
    Start, End, RetrieveFlag= RetrieveFiles(RetrFrom)
    if not RetrieveFlag:
    	ARCHLog.info("Failed to retrieve all of the files")
    	return False
#    print "Start End ", Start, End
    if Start==0 and End ==0:
        ARCHLog.info("No file to retrieve")
    	## No files to return
        return
    First = time.strftime("%m/%d/%Y %H:%M:%S", Start[0])
    Last = time.strftime("%m/%d/%Y %H:%M:%S", End[0])
    ARCHLog.info("%s contains %s at %s to %s at %s" %(File2Write,Start[1],First,End[1],Last))

    NOSOutFile=NOSFileDir+'/'+File2Write
    now=time.gmtime(time.time())
    BufrBulFile = NOSFileDir+'/bufr_queue/'+'BUFR_BUL_%02d-%02d-%04d-%02d%02d%02d' %(now[1],now[2],now[0],now[3],now[4],now[5])

    NOSOut = open(NOSOutFile,'wb')
    BufrOut = open(BufrBulFile,'wb')

    BinFileLoc=NOSFileDir+'/binfiles/'
    bindir = os.listdir(BinFileLoc)
    for files in bindir:
#        print files
        if(os.path.isdir(BinFileLoc+files)):
           continue
        infile = open(BinFileLoc+files,'rb')
        while (1):
            header = infile.read(19)
            if not header:
                break
            remain = int(header[4:14])
            buf = infile.read(remain)
        ##if(!strncmp("IOPX01",NewBuf,6)||!strncmp("IOSX01",NewBuf,6)||!strncmp("IOPX02",NewBuf,6))
            if buf.find('IOPX01') >=0 or buf.find('IOSX01') >=0 or buf.find('IOPX02') >=0:
#                print "BUFR Bulletin"
##                print buf
                BufrOut.write(header+buf)
            else:
                buf = '            '+buf
                NOSOut.write(buf)
                if buf.find('JJXX')>=0  or buf.find('JJYY')>=0 or buf.find('JJVV')>=0 or buf.find('KKXX')>=0 or buf.find('KKYY')>=0:
                    BathyBul = open(NOSFileDir+'/nmc/file%d.txt' %nmcseq, 'wb')
                    BathyBul.write(buf)
                    BathyBul.close()
                    seqfile=open(AMVERWorkDir+'/MessSeq/NMCseq.txt','w')
                    nmcseq += 1
                    seqfile.write(str(nmcseq))
                    seqfile.close()                   
        infile.close()        
    NOSOut.close()
    GateWayFile = 'GW%04d%03d%02d%02d' %(now.tm_year,now.tm_yday,now.tm_hour,now.tm_min)
    shutil.copy(NOSOutFile, NOSFileDir+'/archive/'+GateWayFile)
    shutil.copy(NOSOutFile, '/home/vftp/nossrvr/'+File2Write)
    if BufrOut.tell()==0:
        BufrOut.close()
        os.remove(BufrBulFile)
    else:
        BufrOut.close()
        
        
#***************************************************************************************************
def ReadConf(ConfigFile):
##    global CODE41Archive, CODE41Inbox, CODE43Inbox,  AMVERWorkDir, NWSMessOutDir, CODE43Archive
    global AMVERWorkDir, NWSCollAddr, AOMLBUFRDestDir, DeliverBUFRFiles
    if ConfigFile != '':
        try:
            nossrvr = open(ConfigFile,"r")
        except Exception, e:
            print str(e)
            sys.exit(2)
        
#        print "configfile is \n", ConfigFile
        InfoCount=0
        while 1:
            line=nossrvr.readline()
#            print line
            if len(line)==0:
                break
            colon = line.find(':')
#            print line[0:colon]
            if line[0:colon]=="NWSCollAddr":
                NWSCollAddr=line[colon+1:].strip()
            elif line[0:colon]=="DeliverBUFRFiles":
                DeliverBUFRFiles=line[colon+1:].strip()
            elif line[0:colon]=="AMVERWorkDir":
                AMVERWorkDir=line[colon+1:].strip()
            elif line[0:colon]=="AOMLBUFRDestDir":
                AOMLBUFRDestDir=line[colon+1:].strip()
        nossrvr.close() #close the config file
        return True
    else:
        return False

if __name__ == "__main__":
    logfile = 'NOSSRVRLog'
    NWSCollAddr  = "tggate.nws.noaa.gov"
#    NODCftp = "ftp.aoml.noaa.gov"
#    BathyDir= '/home/AMVER/SEAS/bathy/'
    AOMLBUFRDestDir = 'PaulAOMLTest'
#    NODCDestDir = 'PaulNODCTest'
    DeliverBUFRFiles ='false'
    AMVERWorkDir='/home/AMVER'
    ConfigFile=''
    pidfile = 'NOSSRVR.pid'
    pidfileDir = '/home/AMVER/'
    version = 1.0
    
#  Change the user and group to amver and AMVER

    group = grp.getgrnam("AMVER")
#    print group
    os.setregid(group[2],group[2])
    os.setreuid(group[2],group[2])

#    sys.stderr.write(str(sys.argv) + str(len(sys.argv))+'\n')
    if len(sys.argv)>=2 and operator.mod(len(sys.argv),2)==0:
        command = sys.argv[1]
        for i in range(len(sys.argv)):
#            print ('%d  %s \n' % (i,sys.argv[i]))
            if i<2:
                pass
            elif operator.mod(i,2)==0:
                if sys.argv[i]== '-P':
                    pidfile=sys.argv[i+1]
                elif sys.argv[i]=='-L':
                    logfile=sys.argv[i+1]
                elif sys.argv[i]=='-C':
                    ConfigFile=sys.argv[i+1]
                    if ReadConf(ConfigFile):
                        print AMVERWorkDir, NWSCollAddr, DeliverBUFRFiles,  AOMLBUFRDestDir
                        pidfileDir = AMVERWorkDir
                        pass
                    else:
                        print " Failed to retrieve information from config file"
                        sys.exit(2)
            else:
                pass
        pidfile = (pidfileDir+pidfile)
        daemon = NOSSRVRDaemon(pidfile)
        if 'start' == command:
            print "starting with pidfile = %s\r\n" %pidfile
            daemon.start()
#        else:
#            print "usage: %s start|stop|restart -P pidfile -L logfile -C ConfigFile" % sys.argv[0]
#            sys.exit(2)
#            sys.exit(0)
        elif 'stop' == command:
            daemon.stop()
        elif 'restart' == command:
            daemon.restart()
        elif sys.argv[i]=='-V':
            print 'version %6.2f' %version
        else:
            print "Unknown command"
            sys.exit(2)
    else:
        print "usage: %s start|stop|restart -P pidfile -L logfile -C ConfigFile Directory" % sys.argv[0]
        sys.exit(2)
