## Version 2.00


import sys, time, os, operator
import psycopg2
import psycopg2.extras
import datetime
from datetime import timedelta
import calendar
from stat import *
import Daemon
import logging
import grp
import socket
import smtplib
import email


#######
class WATCHDOGDaemon(Daemon.Daemon):
	def run(self):

		sys.stderr.write("Executing Run \n")
		
		APPLICATION_NAME = "NOAA_WATCHDOG"
		VERSION = "1.0"
		host = socket.gethostname()


		AT= time.gmtime(time.time())
		ARCHFile = AMVERWorkDir+"admin/watchdog/logs/WatchDog-"+("%04d" %AT[0])+("%02d" %AT[1])+("%02d" %AT[2])+".log"
		ARCHLog=logging.getLogger("ArchLog")
		ARCHLog.setLevel(logging.DEBUG)
		handler = logging.FileHandler(ARCHFile)
		Form = logging.Formatter('%(asctime)s %(levelname)-8s %(module)s %(lineno)d %(message)s','%a, %d %b %Y %H:%M:%S')
		handler.setFormatter(Form)
		ARCHLog.addHandler(handler)
		os.chmod(ARCHFile,0660)  #Change mode on logfile
	
		ARCHLog.debug('AMVERWorkDir = %s' %AMVERWorkDir)
		ARCHLog.debug('CODE43Inbox = %s' %CODE43Inbox)
		ARCHLog.debug('CODE41Inbox = %s' %CODE41Inbox)
		ARCHLog.debug('SEASInbox = %s' %SEASInbox)
		ARCHLog.debug('AlertAddress1 = %s' %AlertAddress1)
		ARCHLog.debug('AlertAddress2 = %s' %AlertAddress2)
		ARCHLog.debug('ShipsHost = %s' %ShipsHost)
		
			
###    Enter the Watchdog code here
## New Stuff 

		PIDs=[]
		PIDs.append(["seasprocessor.pid", time.time(),False])
		PIDs.append(["AMVERdist.pid", time.time(),False])
		PIDs.append(["CODE41Mail.pid", time.time(),False])
		PIDs.append(["CODE41Met.pid", time.time(),False])
		PIDs.append(["CODE43Corrector.pid", time.time(),False])
		PIDs.append(["CODE43Mail.pid", time.time(),False])
		PIDs.append(["NDCdist.pid", time.time(),False])
		PIDs.append(["NWSdist.pid", time.time(),False])
		PIDs.append(["QCdist.pid", time.time(),False])
		PIDs.append(["SEASMail.pid", time.time(),False])
		PIDs.append(["USCGdist.pid", time.time(),False])
		PIDs.append(["USCGMail.pid", time.time(),False])
		PIDs.append(["SEASBin.pid", time.time(),False])
		PIDs.append(["NOSSRVR.pid", time.time(),False])
		PIDs.append(["ISDMFiledist.pid", time.time(),False])
		PIDs.append(["NOSBUFRdist.pid", time.time(),False])

		#ScanDirs = []
		PIDs.append([SEASInbox,time.time(),False])
		PIDs.append([CODE41Inbox,time.time(),False])
		PIDs.append([CODE43Inbox,time.time(),False])

		print PIDs
		print

		CheckShips = True
		count = 0
		active = 0
		times=time.time()
		
		while True:

			SendEmail = False
			Message = ""
			for I in range(0,len(PIDs)):
				try:
					if PIDs[I][0].find(AMVERWorkDir)<0:
						st = os.stat(AMVERWorkDir+PIDs[I][0]) # Get the time of pid file so we know we are still running
					else:
						st= os.stat(PIDs[I][0])
					PIDs[I][1] = st[ST_MTIME]
					FT = (time.time()-PIDs[I][1])/60.0
					if FT > 60.0 and not PIDs[I][2]:
						SendEmail = True
						PIDs[I][2] = True
						if os.path.isdir(PIDs[I][0]):
							Message+="%s Directory last written %d minutes ago\n" %(PIDs[I][0],FT)
						else:
							Message+="%s last touched %d minutes ago\n" %(PIDs[I][0],FT)
					elif FT > 60.0 and PIDs[I][2]: #Already sent a message so just continue
						continue
					else:
						PIDs[I][2] = False
					print "%s Pidfile or directory last touched %f minutes ago" %(PIDs[I][0],FT)
				except OSError,e:
					if e.errno==2:  #File missing means the process has crashed must send email alert
						print "the error = 2"
						if not PIDs[I][2]:
							ARCHLog.debug( "Sending email to Administrator")
							PIDs[I][2] = True
							SendEmail = True
							Message += "Pidfile %s is missing. The process is no longer running\n" %PIDs[I][0]
							ARCHLog.debug(Message)
						else:
							ARCHLog.debug( "Not sending email to Administrator")
					print Message
					print
				
			print
	
## Send The Mail Message If Necessary
			if SendEmail:			
				sender = "seas@"+host
#				sender = APPLICATION_NAME+"@"+host
				rec = [AlertAddress1]
				rec.append(AlertAddress2)
				ARCHLog.debug(rec)
				message = "From: %s <%s@%s>\n" %("seas","seas", host)#%(APPLICATION_NAME, APPLICATION_NAME ,host)
				message += "To: %s,%s\n" %(rec[0], rec[1])
				message+= "Subject: Watchdog detected a data flow problem\n"
				message +="X-Mailer: %s %s\n\n"  %(APPLICATION_NAME, VERSION)
				message += Message
				try:
					M=smtplib.SMTP(host)
					ARCHLog.debug("HOST = "+host)
					M.sendmail(sender, rec, message)
					ARCHLog.debug(message)
				except socket.error, e:
					ARCHLog.info("Socket Error %s %s" %(e.errno,e.strerror))
					if M:
						M.quit()
					break
				except socket.timeout:
					ARCHLog.info("Timeout on Connection with file "+N+"\r\n")
					if(M):
						M.quit()
					break
				except OSError, e:
					if e.errno == 13:
						ARCHLog.info("Permission denied to move file %s %s\r\n" %(e.errno,e.strerror))
					continue  # continue to process next file
				except smtplib.SMTPException, e:
					ARCHLog.info("SMTP Exception %s %s" %(e.errno,e.strerror))
					if M:
						M.quit()
				except Exception, e:
#					ARCHLog.info("Exception %s %s" %(e.errno,e.strerror))
					ARCHLog.info("Exception %s" %str(e))
					if M:
						M.quit()

#			Files2Send =0
	
				if M:
					M.quit()
				
## Check for new entries in the ship table				
			count += 1			
			if count >= 60:
				response= os.system("ping -c 1 148.122.180.10")
				if response == 0:
					ARCHLog.info("Pinged EIK")
				else:
					ARCHLog.info("Ping to EIK failed")
				count=0
				try:
					conn_local = psycopg2.connect("dbname='postgres' host='localhost' user='updater' password='stortUB798ger' connect_timeout=20")
					MasterDB = "dbname='postgres' user='seas' host='"+ShipsHost+"' password='revjepeaws' connect_timeout=20"
					conn_remote = psycopg2.connect(MasterDB)  #"dbname='postgres' user='seas' host='140.90.154.71' password='revjepeaws' connect_timeout=20")
				except:
				    ARCHLog.info( "I am unable to connect to the databases")
				    continue
#				    sys.exit(1)
				cur_loc=conn_local.cursor()
				cur_rem = conn_remote.cursor()
				##Get the latest value for updated in the local table
				stmt1 = "select max(updated) from noaaships"
				cur_loc.execute(stmt1)
				row = cur_loc.fetchone()
#				print row

				## Retrieve the tuple for the latest updated time
				stmt1 = "select A.wmo_id,A.shipname,A.lloyds,A.is_alias, A.actual_wmo_id,A.updated from noaaships A where updated = (select max(updated) from noaaships)"
				cur_loc.execute(stmt1)

				row2= cur_loc.fetchall()
				#print row2
				#cur_loc.close()

				now = datetime.datetime.today()
				stmt1 = "select wmo_id,shipname,lloyds,is_alias, actual_wmo_id,updated from noaaships where updated > " + row[0].strftime("'%m/%d/%Y %H:%M:%S'")
				#print stmt1
				cur_rem .execute(stmt1)
				row = cur_rem.fetchall()
				#cur_loc=conn_local.cursor()
#				breakout = False
				for tup in row:
					for tup2 in row2:
						
						if tup == tup2:
							ARCHLog.info( "Record already in DB")
							ARCHLog.info( tup)
						else:
#							print tup
#							print tup2
							actual = '';
							if tup[4]!=None:
								actual = tup[4]
							DT = tup[5]
							Updated = "%0d/%0d/%0d %0d:%0d:%0f" %(DT.month,DT.day,DT.year,DT.hour,DT.minute,DT.second+DT.microsecond/1000000.0)
#							print Updated
							if tup[4]==None:
								stmt2 = "insert into noaaships (wmo_id,shipname,lloyds,is_alias, actual_wmo_id,updated) values ('%s','%s',%d,'%r',NULL,'%s');commit;" %(tup[0],tup[1],tup[2],tup[3], Updated)
							else:
								stmt2 = "insert into noaaships (wmo_id,shipname,lloyds,is_alias, actual_wmo_id,updated) values ('%s','%s',%d,'%r','%s','%s');commit;" %(tup[0],tup[1],tup[2],tup[3],actual, Updated)
							ARCHLog.debug( stmt2)
							try:
								cur_loc.execute(stmt2)
							except:
								ARCHLog.debug("Can't  insert into noaaships")
								break

				cur_rem .close()
				conn_remote.close()
				cur_loc.close()
				conn_local.close()

			Elapsed = int((time.time()-times)/60.0)				
			ARCHLog.info('Active for %s minutes\r\n' %str(Elapsed))
			time.sleep(60)  # wait one minute before checking for new messages
			
			st = os.stat(pidfile) # Touch the pid file so we know we are still running
			atime = st[ST_ATIME]
			FT = time.time()
			os.utime(pidfile,(atime,FT))
			
## Check the date and time to see if a new log file shoule be created.
			AT = time.gmtime(time.time())
			NewARCHFile = AMVERWorkDir+"admin/watchdog/logs/WatchDog-"+("%04d" %AT[0])+("%02d" %AT[1])+("%02d" %AT[2])+".log"
			if os.path.exists(NewARCHFile):
				pass
			else:
				ARCHLog.removeHandler(handler)
				handler.close()
				handler=logging.FileHandler(NewARCHFile)
				handler.setFormatter(Form)
				ARCHLog.addHandler(handler)
				os.chmod(NewARCHFile,0660)  #Change mode on logfile
				ARCHLog.debug('AMVERWorkDir = %s' %AMVERWorkDir)
				ARCHLog.debug('CODE43Inbox = %s' %CODE43Inbox)
				ARCHLog.debug('CODE41Inbox = %s' %CODE41Inbox)
				ARCHLog.debug('SEASInbox = %s' %SEASInbox)
				ARCHLog.debug('AlertAddress1 = %s' %AlertAddress1)
				ARCHLog.debug('AlertAddress2 = %s' %AlertAddress2)
				ARCHLog.debug('ShipsHost = %s' %ShipsHost)

				Elapsed = int((time.time()-times)/60.0)				
				ARCHLog.info('Active for %s minutes\r\n' %str(Elapsed))
				time.sleep(60)  # wait one minute before checking for new messages
				
				st = os.stat(pidfile) # Touch the pid file so we know we are still running
				atime = st[ST_ATIME]
				FT = time.time()
				os.utime(pidfile,(atime,FT))

### Old Stuff



##		except Exception,e:
##			ARCHLog.exception(str(e))
##			sys.exit(2)
				
	
	
def ReadConf(ConfigFile):
##	global CODE41Archive, CODE41Inbox, CODE43Inbox,  AMVERWorkDir, NWSMessOutDir, CODE43Archive
	global AMVERWorkDir, SEASInbox, CODE41Inbox, CODE43Inbox,  AlertAddress1, AlertAddress2, ShipsHost
	if ConfigFile != '':
		try:
			amverdist = open(ConfigFile,"r")
		except Exception, e:
			print str(e)
			sys.exit(2)
		
#		print "configfile is \n", ConfigFile
		InfoCount=0
		while 1:
			line=amverdist.readline()
#			print line
			if len(line)==0:
				break
			colon = line.find(':')
#			print line[0:colon]
			if line[0:colon]=="SEASInbox":
				SEASInbox=line[colon+1:].strip()
			elif line[0:colon]=="CODE41Inbox":
				CODE41Inbox=line[colon+1:].strip()
			elif line[0:colon]=="CODE43Inbox":
				CODE43Inbox=line[colon+1:].strip()
			elif line[0:colon]=="AMVERWorkDir":
				AMVERWorkDir=line[colon+1:].strip()
			elif line[0:colon]=="AlertAddress1":
				AlertAddress1=line[colon+1:].strip()
			elif line[0:colon]=="AlertAddress2":
				AlertAddress2=line[colon+1:].strip()
			elif line[0:colon]=="ShipsHost":
				ShipsHost=line[colon+1:].strip()
		amverdist.close() #close the config file
		return True
	else:
		return False

if __name__ == "__main__":
	logfile = 'WATCHDOGlogfile'
	AMVERWorkDir='/home/AMVER/'
	SEASInbox = '/home/AMVER/SEAS/in/'
	CODE43Inbox = '/home/AMVER/CODE43/in/'
	CODE41Inbox= '/home/AMVER/CODE41/in/'
	AlertAddress1 = 'Paul.Chinn@noaa.gov'
	AlertAddress2 = 'Paul.Chinn@noaa.gov'
	ShipsHost='140.90.154.71'
	ConfigFile=''
	pidfile = 'WATCHDOG.pid'
	pidfileDir = '/home/AMVER/'
	version = 1.0
	
#  Change the user and group to amver and AMVER

	group = grp.getgrnam("AMVER")
#	print group
	os.setregid(group[2],group[2])
	os.setreuid(group[2],group[2])

#	sys.stderr.write(str(sys.argv) + str(len(sys.argv))+'\n')
	if len(sys.argv)>=2 and operator.mod(len(sys.argv),2)==0:
		command = sys.argv[1]
		for i in range(len(sys.argv)):
#			print ('%d  %s \n' % (i,sys.argv[i]))
			if i<2:
				pass
			elif operator.mod(i,2)==0:
				if sys.argv[i]== '-P':
					pidfile=sys.argv[i+1]
				elif sys.argv[i]=='-L':
					logfile=sys.argv[i+1]
				elif sys.argv[i]=='-C':
					ConfigFile=sys.argv[i+1]
					if ReadConf(ConfigFile):
						print AMVERWorkDir,SEASInbox, CODE41Inbox, CODE43Inbox,  AlertAddress1, AlertAddress2
						pidfileDir = AMVERWorkDir
						pass
					else:
						print " Failed to retrieve information from config file"
						sys.exit(2)
			else:
				pass
		pidfile = (pidfileDir+pidfile)
		daemon = WATCHDOGDaemon(pidfile)
		if 'start' == command:
			print "starting with pidfile = %s\r\n" %pidfile
			daemon.start()
#		else:
#			print "usage: %s start|stop|restart -P pidfile -L logfile -C ConfigFile" % sys.argv[0]
#			sys.exit(2)
#			sys.exit(0)
		elif 'stop' == command:
			daemon.stop()
		elif 'restart' == command:
			daemon.restart()
		elif sys.argv[i]=='-V':
			print 'version %6.2f' %version
		else:
			print "Unknown command"
			sys.exit(2)
	else:
		print "usage: %s start|stop|restart -P pidfile -L logfile -C ConfigFile Directory" % sys.argv[0]
		sys.exit(2)

